Admin = {38422}

parse("mp_wpndmg claw 0")
parse("mp_wpndmg_z2 claw 0")
parse("mp_damagefactor 0")
parse("sv_gm 0")
parse("mp_freezetime 3")

lock_ct = false
lock_t = false
stage = 1
gm = 0

function Array(m,v)
     local array = {}
     for i = 1, m do
          array[i]=v
     end
     return array
end

dir = Array(32,0)
count = Array(32,0)
killer = Array(32,0)




addhook("team","team")
function team(id,t)
	if t==1 and lock_t then
		msg2(id,"255255255This team is locked!")
		return 1
	end
	if t==2 and lock_ct then
		msg2(id,"255255255This team is locked!")
		return 1
	end
end

addhook("endround","er")
function er()
	stage = math.random(1,#Stage)
end

addhook("startround","sr")
function sr()
	msg("255255255"..Stage[stage].name.." Stage@C")
end

addhook("attack","attack")
function attack(id)
	parse("setweapon "..id.." 78")
	parse("strip "..id.." 50")
end

addhook("spawn","spawn")
function spawn(id)
	parse("equip "..id.." 78")
	parse("setweapon "..id.." 78")
	parse("strip "..id.." 50")
	count[id] = 0
		repeat
			x = math.random(Stage[stage].t_x*32+16, Stage[stage].ct_x*32+16)
			y = math.random(Stage[stage].t_y*32+16, Stage[stage].ct_y*32+16)
		until tile(math.floor(x/32),math.floor(y/32),"walkable")
		parse("setpos "..id.." "..x.." "..y)
	if stage == 5 then
		if player(id,"team")==1 then
			parse("setpos "..id.." "..(Stage[stage].t_x*32+16).." "..(Stage[stage].t_y*32+16))
		elseif player(id,"team")==2 then
			parse("setpos "..id.." "..(Stage[stage].ct_x*32+16).." "..(Stage[stage].ct_y*32+16))
		end
	end
end

addhook("always","always")
function always()
for id = 1,32 do
	if player(id,"exists") then
		if player(id,"health")>0 and count[id] > 0 then
			local x, y = getpos(player(id,"x"), player(id,"y"), dir[id], 10)
			if tile(math.floor(x/32), math.floor(y/32),"walkable") or tile(math.floor(x/32), math.floor(y/32),"deadly") then
				parse("setpos "..id.." "..x.." "..y)
				count[id] = count[id] - 1
				if count[id] == 0 then
					parse("speedmod "..id.." 0")
					killer[id] = 0
				end
			else
				count[id] = 0
				parse("speedmod "..id.." 0")
				killer[id] = 0
			end
		end
	end
end
end

addhook("die","die")
function die(id)
	if stage == 5 then
		if player(id,"team")==1 then
			parse("spawnplayer "..id.." "..(Stage[stage].t_x*32+16).." "..(Stage[stage].t_y*32+16))
		elseif player(id,"team")==2 then
			parse("spawnplayer "..id.." "..(Stage[stage].ct_x*32+16).." "..(Stage[stage].ct_y*32+16))
		end
	end
end

addhook("movetile","movetile")
function movetile(id,x,y)
	if tile(x,y,"frame")==0 then
		if killer[id]~=0 then
			parse("customkill "..killer[id].." Pushed "..id)
		else
			parse("killplayer "..id)
		end
		count[id] = 0
	end			
end

addhook("hit","hit")
function hit(id,od)
		dir[id] = player(od,"rot")
		count[id] = 15
		parse("speedmod "..id.." -100")
		killer[id] = od
end

function getpos(x, y, dir, speed)
	return x + math.sin(math.rad(dir)) * speed, y + -math.cos(math.rad(dir)) * speed
end

addhook("say","say")
function say(id,txt)
	for _, usgn in ipairs(Admin) do
		if player(id,"usgn") == usgn then
			if txt:sub(1,1)=="-" then
				local p = totable(txt)
				local cmd = string.lower(tostring(p[1]))
				for k, v in pairs(cmd_param) do
					if cmd==v then
						txt = string.sub(txt, #cmd+2, #txt)
						Command(id,cmd,txt)
						return 1
					end
				end
			end
		end
	end

end

addhook("drop","drop")
function drop()
	return 1
end

addhook("projectile","pro_tile")
function pro_tile(id,w,x,y)
	if w == 86 then
	parse("explosion "..x.." "..y.." 200 0 "..id)
		for i = 1,32 do
			if player(i,"exists") then
				if player(i,"health")>0 then
					local dt = math.sqrt((player(i,"x") - x)^2 + (player(i,"y") - y)^2)
					if dt<=90 then
						dir[i] = -math.deg(math.atan2(x - player(i,"x"), y - player(i,"y"))) 	
						count[i] = 12
						killer[i] = id
						parse("speedmod "..i.." -100")
					end
				end
			end
		end
	end
end

function totable(t,match)
     local cmd = {}
     if not match then match = "[^%s]+" end
     for word in string.gmatch(t, match) do
          table.insert(cmd, word)
     end
     return cmd
end

cmd_param = {"-killall","-restart","-lockall","-unlockall","-specall","-ct","-t","-stage","-gm"}

function Command(id,param,txt)
	local p = totable(txt)
	local pl = tonumber(p[1])
	if param==cmd_param[1]then
		for i = 1,32 do
			if player(i,"exists") then
				if player(i,"health")>0 then
					parse("killplayer "..i)
				end
			end
		end
	elseif param==cmd_param[2]then
		parse("restart")
	elseif param==cmd_param[3]then
		lock_ct = true
		lock_t = true
		msg("255255255CTs and Ts are locked!")
	elseif param==cmd_param[4]then
		lock_ct = false
		lock_t = false
		msg("255255255CTs and Ts are unlocked!")
	elseif param==cmd_param[5]then
		for i = 1,32 do
			if player(i,"exists") then
				parse("makespec "..i)
			end
		end	
	elseif param==cmd_param[6]then
		for i = 1,32 do
			local pl = tonumber(p[i])
			if pl~=nil then
				if lock_ct then
					lock_ct = false
					parse("makect "..pl)
					lock_ct = true
				else
					parse("makect "..pl)
				end
			end
		end
	elseif param==cmd_param[7]then
		for i = 1,32 do
			local pl = tonumber(p[i])
			if pl~=nil then
				if lock_t then
					lock_t = false
					parse("maket "..pl)
					lock_t = true
				else
					parse("maket "..pl)
				end
			end
		end
	elseif param==cmd_param[8]then
		if pl ~= nil then
			if pl >= 1 and pl<=#Stage then
				parse("restart")
				stage = pl
			end
		end
	elseif param==cmd_param[9]then
		if pl ~= nil then
			if pl >= 0 and pl<=4 then
				parse("sv_gm "..pl)
				gm = pl
			end
		end
	end
end


Stage = {
		[1] = {
				name = "Wooden",
				ct_x =16,
				ct_y =18,
				t_x =7,
				t_y =9,
			},
		[2] = {
				name = "Grass",
				ct_x =43,
				ct_y =18,
				t_x =34,
				t_y =9,
			},
		[3] = {
				name = "Stone",
				ct_x =16,
				ct_y =40,
				t_x =7,
				t_y =31,
			},
		[4] = {
				name = "Water",
				ct_x =43,
				ct_y =40,
				t_x =34,
				t_y =31,
			},
		[5] = {
				name = "CTF Snow Fight",
				ct_x =12,
				ct_y =75,
				t_x =12,
				t_y =50,
			},
}